"use strict";
//**/////////////////////////////////////////////////////////////////////////////////////////
// Author: Đào Quốc Huy / huydaoquoc88@gmail.com
// Description: Validation for Base64 string. Valid if input is [BASE64, "", null, undefined]// 
/////////////////////////////////////////////////////////////////////////////////////////////
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsBase64CustomConstraint = exports.IsBase64Custom = void 0;
const class_validator_1 = require("class-validator");
function IsBase64Custom(validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [],
            validator: IsBase64CustomConstraint,
        });
    };
}
exports.IsBase64Custom = IsBase64Custom;
let IsBase64CustomConstraint = class IsBase64CustomConstraint {
    validate(value, validationArguments) {
        if (value === null || value === undefined || (0, class_validator_1.isBase64)(value)) { //isBase64() true if string is "" or base64
            return true;
        }
        else {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return 'validation.INVALID_BASE64';
    }
};
IsBase64CustomConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsBase64Custom', })
], IsBase64CustomConstraint);
exports.IsBase64CustomConstraint = IsBase64CustomConstraint;
//# sourceMappingURL=is-base64-custom.validator.js.map