"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsInRangeCustomConstraint = exports.IsInRangeCustom = void 0;
const class_validator_1 = require("class-validator");
function IsInRangeCustom(min, max, validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [min, max],
            validator: IsInRangeCustomConstraint,
        });
    };
}
exports.IsInRangeCustom = IsInRangeCustom;
let IsInRangeCustomConstraint = class IsInRangeCustomConstraint {
    validate(value, validationArguments) {
        try {
            value = parseInt(value);
            if (typeof value === "number" && value >= validationArguments.constraints[0] && value <= validationArguments.constraints[1]) {
                return true;
            }
            else {
                return false;
            }
        }
        catch (error) {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return 'validation.INVALID_RANGE_OF_NUMBER';
    }
};
IsInRangeCustomConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsInRangeCustom' })
], IsInRangeCustomConstraint);
exports.IsInRangeCustomConstraint = IsInRangeCustomConstraint;
//# sourceMappingURL=is-in-range-custom.validator.js.map