"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsInRangeOfDateConstraint = exports.IsInRangeOfDate = void 0;
const class_validator_1 = require("class-validator");
function IsInRangeOfDate(min, max, validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [new Date(min).toLocaleDateString('en-US'), new Date(max).toLocaleDateString('en-US'), min, max],
            validator: IsInRangeOfDateConstraint,
        });
    };
}
exports.IsInRangeOfDate = IsInRangeOfDate;
let IsInRangeOfDateConstraint = class IsInRangeOfDateConstraint {
    validate(value, validationArguments) {
        // console.log(typeof value)
        // console.log(value)
        // console.log(validationArguments)
        try {
            value = parseInt(value);
            if (typeof value === "number" && value >= validationArguments.constraints[2] && value <= Date.now()) {
                validationArguments.constraints[1] = new Date(validationArguments.constraints[3]).toLocaleDateString('en-US');
                return true;
            }
            else {
                return false;
            }
        }
        catch (error) {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return "validation.INVALID_RANGE_OF_DATE";
        // return "{"+validationArguments.property + "} " + "response.message.phoneFormatIsWrong
    }
};
IsInRangeOfDateConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsInRangeOfDate' })
], IsInRangeOfDateConstraint);
exports.IsInRangeOfDateConstraint = IsInRangeOfDateConstraint;
//# sourceMappingURL=is-in-range-of-date.validator.js.map