"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsMongoObjectIdConstraint = exports.IsMongoObjectId = void 0;
const class_validator_1 = require("class-validator");
function IsMongoObjectId(validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            validator: IsMongoObjectIdConstraint,
        });
    };
}
exports.IsMongoObjectId = IsMongoObjectId;
let IsMongoObjectIdConstraint = class IsMongoObjectIdConstraint {
    validate(value) {
        try {
            if (typeof value === "string") {
                return value === new (require('mongoose').Types.ObjectId)(value).toString();
            }
            else {
                return false;
            }
        }
        catch (error) {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return "validation.INVALID_MONGO_ID";
        // return "{"+validationArguments.property + "} " + "response.message.mongoObjectIdWrong
    }
};
IsMongoObjectIdConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsMongoObjectId' })
], IsMongoObjectIdConstraint);
exports.IsMongoObjectIdConstraint = IsMongoObjectIdConstraint;
//# sourceMappingURL=is-mongdo-object-id.validator.js.map