"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsNumberCustomConstraint = exports.IsNumberCustom = void 0;
const class_validator_1 = require("class-validator");
function IsNumberCustom(validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            validator: IsNumberCustomConstraint,
        });
    };
}
exports.IsNumberCustom = IsNumberCustom;
let IsNumberCustomConstraint = class IsNumberCustomConstraint {
    validate(value, validationArguments) {
        if (typeof value === "number") {
            return true;
        }
        else if (typeof value === "string" && value.match(/ /) !== null) {
            return false;
        }
        else if (typeof value === "string") {
            let valueParse = parseFloat(value);
            if ((value !== undefined && value !== null && !isNaN(valueParse)) && typeof valueParse === "number") {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return "validation.INVALID_NUMBER";
        // return "{"+validationArguments.property + "} " + "response.message.stringValidationFailed
    }
};
IsNumberCustomConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsNumberCustom' })
], IsNumberCustomConstraint);
exports.IsNumberCustomConstraint = IsNumberCustomConstraint;
//# sourceMappingURL=is-number-custom.validator.js.map