"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsRepeatConstraint = exports.IsRepeat = void 0;
const class_validator_1 = require("class-validator");
function IsRepeat(property, validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [property],
            validator: IsRepeatConstraint,
        });
    };
}
exports.IsRepeat = IsRepeat;
let IsRepeatConstraint = class IsRepeatConstraint {
    validate(value, args) {
        const [relatedPropertyName] = args.constraints;
        const relatedValue = args.object[relatedPropertyName];
        return value === relatedValue;
    }
    defaultMessage(validationArguments) {
        return "validation.REPEAT_DOES_NOT_MATCH";
        // return "{"+validationArguments.property + "} " + "response.message.passwordRepeatNotMatch
    }
};
IsRepeatConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsRepeat' }) // exact math when IsRepeat input. Example: @IsRepeat('password', { message: 'Password and confirm password does not match' })
], IsRepeatConstraint);
exports.IsRepeatConstraint = IsRepeatConstraint;
//# sourceMappingURL=is-repeat.validator.js.map