"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaxImageBase64ByteSizeConstraint = exports.MaxImageBase64ByteSize = void 0;
const class_validator_1 = require("class-validator");
function MaxImageBase64ByteSize(max, validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            // ` (${Math.ceil(validationOptions.context.value.length *(3/4)/1024)}/${max/1024} kB)`
            constraints: [max, max / 1024],
            validator: MaxImageBase64ByteSizeConstraint,
        });
    };
}
exports.MaxImageBase64ByteSize = MaxImageBase64ByteSize;
let MaxImageBase64ByteSizeConstraint = class MaxImageBase64ByteSizeConstraint {
    validate(value, validationArguments) {
        if (value === undefined || value === "" || value === null) {
            return true;
        }
        else if (typeof value == "string" && Math.ceil(value.length * (3 / 4)) <= validationArguments.constraints[0]) { // tính theo byte
            return true;
        }
        else {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return ` (${Math.ceil(validationArguments.value.length * (3 / 4) / 1024)}/${validationArguments.constraints[0] / 1024} kB)`;
        // return "{"+validationArguments.property + "} " + "response.message.phoneFormatIsWrong
    }
};
MaxImageBase64ByteSizeConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'MaxImageBase64ByteSize' })
], MaxImageBase64ByteSizeConstraint);
exports.MaxImageBase64ByteSizeConstraint = MaxImageBase64ByteSizeConstraint;
//# sourceMappingURL=max-image-base64-byte-size-custom.validator.js.map