"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsNotEmpty_I18nConstraint = exports.IsNotEmpty_I18n = void 0;
/**
* Author: Đào Quốc Huy / huydaoquoc88@gmail.com
* Description: Invalid empty (null, undefined, "")
*/
const class_validator_1 = require("class-validator");
/**
 * @Example `@IsNotEmpty_I18n()`.
 * @Return false if not set, or empty "" or just space ""
 * @Require i18n translate: "validation.CAN_NOT_BE_EMPTY"
 */
function IsNotEmpty_I18n(validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [],
            validator: IsNotEmpty_I18nConstraint,
        });
    };
}
exports.IsNotEmpty_I18n = IsNotEmpty_I18n;
let IsNotEmpty_I18nConstraint = class IsNotEmpty_I18nConstraint {
    validate(value, validationArguments) {
        if (value !== undefined && value != null) {
            if (typeof value === "string" && value.replace(/ /, "") === "") {
                return false;
            }
            else {
                return true;
            }
        }
        else {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return "validation.CAN_NOT_BE_EMPTY";
    }
};
IsNotEmpty_I18nConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsNotEmpty_I18n' })
], IsNotEmpty_I18nConstraint);
exports.IsNotEmpty_I18nConstraint = IsNotEmpty_I18nConstraint;
//# sourceMappingURL=is-not-empty.validator.js.map