"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsNumber_I18nConstraint = exports.IsNumber_I18n = void 0;
/**
* Author: Đào Quốc Huy / huydaoquoc88@gmail.com
* Description: Accept number, empty
*/
const class_validator_1 = require("class-validator");
/**
 * @Example `@IsNumber_I18n()`.
 * @Return true if not set
 * @Require i18n translate: "validation.INVALID_NUMBER"
 */
function IsNumber_I18n(validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [],
            validator: IsNumber_I18nConstraint,
        });
    };
}
exports.IsNumber_I18n = IsNumber_I18n;
let IsNumber_I18nConstraint = class IsNumber_I18nConstraint {
    validate(value, validationArguments) {
        if (typeof value === "number") {
            return true;
        }
        else if (typeof value === "string" && value.match(/ /) !== null) { // dont space
            return false;
        }
        else if (typeof value === "string") {
            let valueParse = parseFloat(value);
            if ((value !== undefined && value !== null && !isNaN(valueParse)) && typeof valueParse === "number") {
                return true;
            }
            else if (typeof value === undefined || value === null) {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }
    defaultMessage(validationArguments) {
        return "validation.INVALID_NUMBER";
    }
};
IsNumber_I18nConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsNumber_I18n' })
], IsNumber_I18nConstraint);
exports.IsNumber_I18nConstraint = IsNumber_I18nConstraint;
//# sourceMappingURL=is-number.validator.js.map