/**
* Author: Đào Quốc Huy / huydaoquoc88@gmail.com
* Description: word contain [A-Za-z0-9], digit contain [0-9]. Not allow empty, null, undefined input value
*/
import { ValidationArguments, ValidationOptions, ValidatorConstraintInterface } from 'class-validator';
/**
 * @Example `@IsOTP_I18n("word",4,{message:i18nValidationMessage('validation.INVALID_OTP')})`.
 * @Param `type`: Default: "digit" ([0-9]). Set "word" for ([A-Za-z0-9]).
 * @Param `length`: Default: 6.
 * @Return false if not match any condition, or not set
 * @Require i18n translate: "validation.INVALID_OTP"
 */
export declare function IsOTP_I18n(type: "word" | "digit", length: number, validationOptions: ValidationOptions): (object: any, propertyName: string) => void;
export declare class IsOTP_I18nConstraint implements ValidatorConstraintInterface {
    validate(value: any, validationArguments: ValidationArguments): boolean;
    defaultMessage(validationArguments?: ValidationArguments): string;
}
//# sourceMappingURL=is-otp.validator.d.ts.map