"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsOTP_I18nConstraint = exports.IsOTP_I18n = void 0;
/**
* Author: Đào Quốc Huy / huydaoquoc88@gmail.com
* Description: word contain [A-Za-z0-9], digit contain [0-9]. Not allow empty, null, undefined input value
*/
const class_validator_1 = require("class-validator");
/**
 * @Example `@IsOTP_I18n("word",4,{message:i18nValidationMessage('validation.INVALID_OTP')})`.
 * @Param `type`: Default: "digit" ([0-9]). Set "word" for ([A-Za-z0-9]).
 * @Param `length`: Default: 6.
 * @Return false if not match any condition, or not set
 * @Require i18n translate: "validation.INVALID_OTP"
 */
function IsOTP_I18n(type = "digit", length = 6, validationOptions) {
    return (object, propertyName) => {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            constraints: [type, length],
            validator: IsOTP_I18nConstraint,
        });
    };
}
exports.IsOTP_I18n = IsOTP_I18n;
let IsOTP_I18nConstraint = class IsOTP_I18nConstraint {
    validate(value, validationArguments) {
        let validation = false;
        if (typeof value === "string") { // first condition
            if (validationArguments.constraints[0] === "digit" && value.match(RegExp("(^[0-9]{" + validationArguments.constraints[1] + "}$)"))) {
                console.log("1");
                validation = true;
            }
            else if (validationArguments.constraints[0] === "word" && value.match(RegExp("(^[A-Za-z0-9]{" + validationArguments.constraints[1] + "}$)"))) {
                console.log("2");
                validation = true;
            }
            else {
                validation = false;
            }
        }
        else {
            validation = false;
        }
        return validation;
    }
    defaultMessage(validationArguments) {
        return "validation.INVALID_OTP";
        // return "{"+validationArguments.property + "} " +  "response.message.otpFormatIsWrong
    }
};
IsOTP_I18nConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'IsOTP_I18n' })
], IsOTP_I18nConstraint);
exports.IsOTP_I18nConstraint = IsOTP_I18nConstraint;
//# sourceMappingURL=is-otp.validator.js.map