import { registerDecorator, ValidationArguments, ValidationOptions, ValidatorConstraint, ValidatorConstraintInterface } from 'class-validator';


export function IsPassword(validationOptions?: ValidationOptions) {
    return (object: any, propertyName: string) => {
        registerDecorator({
            target: object.constructor,
            propertyName,
            options: validationOptions,
            // constraints: [],
            validator: IsPasswordConstraint,
        });
    };
}

@ValidatorConstraint({ name: 'IsPassword' })
export class IsPasswordConstraint implements ValidatorConstraintInterface {

    validate(value: any, validationArguments?: ValidationArguments) {
         // #?!@$%^&*+-._
        if (typeof value === "string" && value.match(/^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9]).{6,}$/) && value.match(/[\<\>\/\[\]\{\}]/) === null) {
            return true
        } else {
            return false
        }
    }
    defaultMessage(validationArguments?: ValidationArguments): string {
        // console.log(validationArguments)
        return "validation.INVALID_PASSWORD"
    }

}